unit Form_AddEditSchedule;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WND_DEFAULTWINDOW, StdCtrls, Mask, ToolEdit, ComCtrls, ExtCtrls,
  Buttons;

type
  TEditMode = (emEdit,emInsert);

type
  TfrmAddEditSchedule = class(TfrmRODefault)
    Panel1: TPanel;
    cbTime: TComboBox;
    Label1: TLabel;
    PageControl1: TPageControl;
    tsOncePerDay: TTabSheet;
    Label5: TLabel;
    deOncePerDay: TDateTimePicker;
    tsOncePerWeek: TTabSheet;
    Label3: TLabel;
    Label4: TLabel;
    cbOncePerWeek: TComboBox;
    deOncePerWeek: TDateTimePicker;
    tsFewTimesPerDay: TTabSheet;
    Label2: TLabel;
    Label6: TLabel;
    cbGenEvery: TComboBox;
    tsOnce: TTabSheet;
    Label7: TLabel;
    Label8: TLabel;
    deGenDay: TDateEdit;
    deOnce: TDateTimePicker;
    tsOncePerMonth: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    cbDayOfMonth: TComboBox;
    deOncePerMonth: TDateTimePicker;
    PageControl2: TPageControl;
    tsRemind: TTabSheet;
    memoNotify: TMemo;
    Panel3: TPanel;
    Label11: TLabel;
    tsMessage: TTabSheet;
    memoMessage: TMemo;
    Panel4: TPanel;
    Label12: TLabel;
    tsPublicMessage: TTabSheet;
    edMessage: TEdit;
    Panel5: TPanel;
    Label13: TLabel;
    tsShutDown: TTabSheet;
    Panel2: TPanel;
    Label14: TLabel;
    tsNone: TTabSheet;
    Panel6: TPanel;
    cbActive: TCheckBox;
    Label15: TLabel;
    cbOperation: TComboBox;
    Label16: TLabel;
    cbShutdown: TComboBox;
    Panel7: TPanel;
    edDescription: TLabeledEdit;
    cbUser: TComboBox;
    Label17: TLabel;
    Label18: TLabel;
    cbMsgUser: TComboBox;
    Panel8: TPanel;
    Label19: TLabel;
    Panel9: TPanel;
    fnSound: TFilenameEdit;
    procedure cbTimeChange(Sender: TObject);
    procedure cbOperationChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure edDescriptionKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    aScheduleName : String;
  public
    EditMode : TEditMode;
    Constructor Create(aName : String); Reintroduce; Overload;
  end;

var
  frmAddEditSchedule: TfrmAddEditSchedule;

implementation

uses IniFiles,wcConsts,DateUtils;




{$R *.dfm}

procedure TfrmAddEditSchedule.cbTimeChange(Sender: TObject);
begin
  inherited;
PageControl1.ActivePageIndex := cbTime.ItemIndex;
end;

procedure TfrmAddEditSchedule.cbOperationChange(Sender: TObject);
begin
  inherited;
PageControl2.ActivePageIndex := cbOperation.ItemIndex ;
end;

constructor TfrmAddEditSchedule.Create(aName: String);
var I : Integer;
begin

ROFlatControls := True;

ROShowHeader   := True;

inherited Create(Application);

aScheduleName := aName ;

for i:=0 to tblUsers.Count-1 Do
    Begin
    cbUser.Items.Add(TUser(tblUsers[i]).USERNAME);
    cbMsgUser.Items.Add(TUser(tblUsers[i]).USERNAME);
    End;

deOncePerDay.Time := Time;
deOncePerWeek.Time := Time;
deGenDay.Date := Date;
deOnce.Time  := Time;
deOncePerMonth.Time := Time;

end;

procedure TfrmAddEditSchedule.FormShow(Sender: TObject);
var aTempStr : String;
    I : Integer;
begin
  inherited;

  if aScheduleName <> '' then
     Begin

     edDescription.OnKeyUp := Nil;
     edDescription.Enabled := False;
     edDescription.text := aScheduleName;

     With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
          Begin
          cbOperation.ItemIndex := ReadInteger(CurrentNick+aScheduleName,'Kind',1)-1;
          cbOperationChange(Self);

          cbTime.ItemIndex := ReadInteger(CurrentNick+aScheduleName,'TimeSchema',1)-1;
          cbTimeChange(Self);

           Case cbTime.ItemIndex of
                0: deOncePerDay.Time := ReadTime(CurrentNick+aScheduleName,'Time',Now);
                1: Begin
                   cbOncePerWeek.ItemIndex:= ReadInteger(CurrentNick+aScheduleName,'Day',0)-1;
                   deOncePerWeek.Time := ReadTime(CurrentNick+aScheduleName,'Time',Now);
                   End;
                2: Begin
                   aTempStr := ReadString(CurrentNick+aScheduleName,'Minutes','10');

                   for i:=0 To cbGenEvery.Items.Count-1 DO
                       If cbGenEvery.Items[i]= aTempStr then
                          Begin
                          cbGenEvery.ItemIndex := i;
                          Break;
                          End;

                   End;
                3: Begin
                   deGenDay.Date := ReadDate(CurrentNick+aScheduleName,'Date',Date);
                   deOnce.Time   := ReadTime(CurrentNick+aScheduleName,'Time',Time);
                   End;
                4: Begin
                   aTempStr := ReadString(CurrentNick+aScheduleName,'Day','1');

                   for i:=0 To cbDayOfMonth.Items.Count-1 DO
                       If cbDayOfMonth.Items[i]= aTempStr then
                          Begin
                          cbDayOfMonth.ItemIndex := i;
                          Break;
                          End;
                   deOncePerMonth.Time := ReadTime(CurrentNick+aScheduleName,'Time',now);
                   End;
                End;

             Case cbOperation.ItemIndex of
                  0: Begin
                     memoNotify.Text := ReadString(CurrentNick+aScheduleName,'Message','');
                     fnSound.Text    := ReadString(CurrentNick+aScheduleName,'Sound','');
                     End;
                  1: Begin
                     cbMsgUser.Text := ReadString(CurrentNick+aScheduleName,'User','');
                     memoMessage.Text := ReadString(CurrentNick+aScheduleName,'Message','');
                     End;
                  2: edMessage.Text   := ReadString(CurrentNick+aScheduleName,'Message','');
                  3: Begin
                     cbUser.Text := ReadString(CurrentNick+aScheduleName,'User','');
                     cbShutdown.ItemIndex := ReadInteger(CurrentNick+aScheduleName,'Method',0);
                     End;
                  End;

          cbActive.Checked := ReadBool(CurrentNick+aScheduleName,'Enabled',True);

          Free;
          End;

     End
     Else
     btnok.Enabled := False

end;

procedure TfrmAddEditSchedule.btnOkClick(Sender: TObject);
var StrList,aScheduleList : TStrings;
    I : Integer;
begin

aScheduleName := edDescription.Text;

  With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
       Begin

       if EditMode = emInsert Then
          Begin
          StrList := TStringList.Create;
          aScheduleList := TStringList.Create;

          ReadSection(CurrentNick,StrList);

          for i:=0 to StrList.Count-1 Do
               aScheduleList.Add(ReadString(CurrentNick,StrList[i],''));

          aScheduleList.Add(edDescription.Text);
          EraseSection(CurrentNick);

          For I:=0 to aScheduleList.Count-1 DO
              WriteString(CurrentNick,IntToStr(I+1),aScheduleList[i]);

          aScheduleList.Free;
          StrList.Free;
          End;


       WriteInteger(CurrentNick+aScheduleName,'TimeSchema',cbTime.ItemIndex+1);
       WriteInteger(CurrentNick+aScheduleName,'Kind',cbOperation.ItemIndex+1);

       Case cbTime.ItemIndex of
            0: WriteTime(CurrentNick+aScheduleName,'Time',deOncePerDay.Time);
            1: Begin
               WriteInteger(CurrentNick+aScheduleName,'Day',cbOncePerWeek.ItemIndex+1);
               WriteTime(CurrentNick+aScheduleName,'Time',deOncePerWeek.Time);
               End;
            2: WriteString(CurrentNick+aScheduleName,'Minutes',cbGenEvery.Text);
            3: Begin
               WriteDate(CurrentNick+aScheduleName,'Date',deGenDay.Date);
               WriteTime(CurrentNick+aScheduleName,'Time',deOnce.Time);
               End;
            4: Begin
               WriteString(CurrentNick+aScheduleName,'Day',cbDayOfMonth.Text);
               WriteTime(CurrentNick+aScheduleName,'Time',deOncePerMonth.Time);
               End;
            End;

       Case cbOperation.ItemIndex of
            0: Begin
               WriteString(CurrentNick+aScheduleName,'Message',StringReplace(memoNotify.Text,'#13','',[rfReplaceAll]));
               WriteString(CurrentNick+aScheduleName,'Sound',fnSound.Text);
               End;
            1: Begin
               WriteString(CurrentNick+aScheduleName,'Message',StringReplace(memoMessage.Text,'#13','',[rfReplaceAll]));
               WriteString(CurrentNick+aScheduleName,'User',cbMsgUser.Text);
               End;
            2: WriteString(CurrentNick+aScheduleName,'Message',edMessage.Text);
            3: Begin
               WriteString(CurrentNick+aScheduleName,'User',cbUser.Text);
               WriteInteger(CurrentNick+aScheduleName,'Method',cbShutdown.ItemIndex);
               End;
            End;

       WriteBool(CurrentNick+aScheduleName,'Enabled',cbActive.Checked);

       Free;
       End;

  inherited;


end;

procedure TfrmAddEditSchedule.edDescriptionKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  inherited;

  btnOk.Enabled := edDescription.Text<>'';


end;

end.
