unit Form_Notification;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WND_DEFAULTWINDOW, StdCtrls, Buttons, ExtCtrls;

type
  TfrmNotification = class(TfrmRODefault)
    Panel1: TPanel;
    Panel2: TPanel;
    memoNotification: TMemo;
    cbAgain: TCheckBox;
    cbMinutes: TComboBox;
    Label1: TLabel;
    cbRemoveTask: TCheckBox;
    cbDisableTask: TCheckBox;
    procedure cbAgainClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
  private
    aName : String;
  public
    Constructor Create( SchName : String ) ; Reintroduce ; Overload;
  end;

var
  frmNotification: TfrmNotification;

implementation

Uses IniFiles,wcConsts,DateUtils;

{$R *.dfm}

procedure TfrmNotification.cbAgainClick(Sender: TObject);
begin
  inherited;

   cbMinutes.Enabled := cbAgain.Checked;
   Label1.Enabled    := cbAgain.Checked;

   cbRemoveTask.Enabled := not cbAgain.Checked;

end;

constructor TfrmNotification.Create(SchName: String);
begin

ROFlatControls := True;

ROShowHeader   := true;
Inherited Create(Application);

aName := SchName ;
end;

procedure TfrmNotification.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin

Action := caFree;
  inherited;

end;

procedure TfrmNotification.FormDestroy(Sender: TObject);
begin
  inherited;
frmNotification := Nil;
end;

procedure TfrmNotification.btnOkClick(Sender: TObject);
var StrList : TStrings;
    I : Integer;
begin


if cbDisableTask.Checked then
   Begin
   With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
        begin
        WriteBool(CurrentNick+aName,'Enabled',False);
        Free;
        End;
   End;

if cbAgain.Checked AND cbAgain.Enabled then
   Begin
   With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
        begin

        WriteDate(CurrentNick+aName,'Date',Date);
        WriteTime(CurrentNick+aName,'Time',IncMinute(IncMinute(Now,StrToInt(cbMinutes.Text))));
        WriteBool(CurrentNick+aName,'Enabled',True);
        Free;
        End;
   End;


if cbRemoveTask.Checked then
   Begin
   With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
        begin
        EraseSection(CurrentNick+aName);

        StrList := TStringList.Create;
        ReadSection(CurrentNick,StrList);
        for i:=0 to StrList.Count-1 Do
            Begin
            if ReadString(CurrentNick,StrList[i],'')=aName then
               Begin
               DeleteKey(CurrentNick,StrList[i]);
               Break;
               End;
            End;
        StrList.Free;
        Free;
        End;
   End;

Close;

end;

end.
