unit Form_Scheduler;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms,
  Dialogs, WND_DEFAULTWINDOW, StdCtrls, Buttons, ExtCtrls,
  ToolEdit, ActnList, ImgList, Controls, ComCtrls, Menus;


type
  TfrmScheduler = class(TfrmRODefault)
    Panel1: TPanel;
    lvTasks: TListView;
    PageControl1: TPageControl;
    tsRemind: TTabSheet;
    tsMessage: TTabSheet;
    tsPublicMessage: TTabSheet;
    memoNotify: TMemo;
    memoMessage: TMemo;
    edMessage: TEdit;
    tsShutDown: TTabSheet;
    Panel2: TPanel;
    Label4: TLabel;
    Panel3: TPanel;
    Label1: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    Panel5: TPanel;
    Label3: TLabel;
    edUser: TLabeledEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ImageList1: TImageList;
    ActionList1: TActionList;
    acEdit: TAction;
    acRemove: TAction;
    acAdd: TAction;
    tsNone: TTabSheet;
    ImageList2: TImageList;
    PopupMenu1: TPopupMenu;
    Add1: TMenuItem;
    Edit1: TMenuItem;
    Remove1: TMenuItem;
    Label16: TLabel;
    cbShutdown: TComboBox;
    edMsgUser: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure acAddExecute(Sender: TObject);
    procedure acEditExecute(Sender: TObject);
    procedure lvTasksClick(Sender: TObject);
    procedure acRemoveExecute(Sender: TObject);
  private


  public
    Procedure LoadLVData ;  Override;
    Procedure UpdateControls; Override;
  end;

var
  sOncePerDay      : String= 'Once per day at %s';
  sOncePerWeekAt   : String ='Once per week at %s, %s';
  sFewTimesPerDay  : String ='Few times per day, every %s minutes';
  sOnce            : String ='Once, at %s, %s';
  sDayOfEveryMonth : String ='Day %s of every month, %s';

var
  frmScheduler: TfrmScheduler;
  aParentApp : THandle;

implementation

Uses IniFiles,wcConsts,Form_AddEditSchedule;
{$R *.dfm}


procedure TfrmScheduler.FormCreate(Sender: TObject);
begin

ROShowHeader := True;
ROFlatControls := true;

inherited ;

end;



procedure TfrmScheduler.btnOkClick(Sender: TObject);
Begin
Close;
end;

procedure TfrmScheduler.FormShow(Sender: TObject);
begin
LoadLVData;
end;



procedure TfrmScheduler.acAddExecute(Sender: TObject);
begin

  inherited;
With TfrmAddEditSchedule.Create('') Do
     Begin
     EditMode := emInsert;
     ShowModal;

     If ModalResult = mrOK then
        self.LoadLVData;
     Free;
     End;
end;


procedure TfrmScheduler.LoadLVData;
var StrList : TStrings;
    I : Integer;
begin

lvTasks.Clear;

StrList := TStringList.Create;


With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
     Begin
     ReadSection(CurrentNick,StrList);
     for i:=0 to StrList.Count-1 Do
         Begin
         With lvTasks.Items.Add Do
              Begin
              Caption := ReadString(CurrentNick,StrList[i],'');

              Case ReadInteger(CurrentNick+Caption,'TimeSchema',1) of
                   1: SubItems.Add(Format(sOncePerDay,[FormatDateTime('HH:mm',ReadTime(CurrentNick+Caption,'Time',Now))]));
                   2: SubItems.Add(Format(sOncePerWeekAt,[LongDayNames[ReadInteger(CurrentNick+Caption,'Day',0)],
                                                                     FormatDateTime('HH:mm',ReadDateTime(CurrentNick+Caption,'Time',Now)) ]));

                   3: SubItems.Add(Format(sFewTimesPerDay,[ReadString(CurrentNick+Caption,'Minutes','1')]));
                   4: SubItems.Add(Format(sOnce,[FormatDateTime('dd-mm-yyyy',ReadDateTime(CurrentNick+Caption,'Date',Now)),
                                                             FormatDateTime('HH:mm',ReadDateTime(CurrentNick+Caption,'Time',Now)) ]));
                   5: SubItems.Add(Format(sDayOfEveryMonth,[ReadString(CurrentNick+Caption,'Day','1'),
                                                                     FormatDateTime('HH:mm',ReadDateTime(CurrentNick+Caption,'Time',Now)) ]));
                   End;

              ImageIndex := ReadInteger(CurrentNick+Caption,'Enabled',Integer(true))

              End;
         End;
     Free;
     End;

StrList.Free;

  inherited;

  UpdateControls;

end;

procedure TfrmScheduler.acEditExecute(Sender: TObject);
begin

if lvTasks.SelCount=0 then Exit;

With TfrmAddEditSchedule.Create(lvTasks.Selected.Caption) Do
     Begin
     EditMode := emEdit;
     ShowModal;
     If ModalResult = mrOK then
        self.LoadLVData;
     Free;
     End;
end;


procedure TfrmScheduler.lvTasksClick(Sender: TObject);
begin

  inherited;
UpdateControls;

end;

procedure TfrmScheduler.UpdateControls;
begin

acEdit.Enabled   := lvTasks.SelCount>0;
acRemove.Enabled := lvTasks.SelCount>0;

if lvTasks.SelCount>0 then
   Begin
   With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
        Begin
        PageControl1.ActivePageIndex := ReadInteger(CurrentNick+lvTasks.Selected.Caption,'Kind',1)-1;
        Case PageControl1.ActivePageIndex of
             0: memoNotify.Text := ReadString(CurrentNick+lvTasks.Selected.Caption,'Message','');
             1: Begin
                edMsgUser.Text := ReadString(CurrentNick+lvTasks.Selected.Caption,'User','');
                memoMessage.Text:= ReadString(CurrentNick+lvTasks.Selected.Caption,'Message','');
                End;
             2: edMessage.Text  :=  ReadString(CurrentNick+lvTasks.Selected.Caption,'Message','');
             3: Begin
                edUser.Text := ReadString(CurrentNick+lvTasks.Selected.Caption,'User','');
                cbShutdown.ItemIndex := ReadInteger(CurrentNick+lvTasks.Selected.Caption,'Method',0);
                End;
             End;

        Free;
        End;
   End
   Else
   PageControl1.ActivePageIndex := 4;


end;

procedure TfrmScheduler.acRemoveExecute(Sender: TObject);
var StrList : TStrings;
    I : Integer;
begin

StrList := TStringList.Create;

if lvTasks.SelCount=0 then Exit;
With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
     Begin
     EraseSection(CurrentNick+lvTasks.Selected.Caption);

     ReadSection(CurrentNick,StrList);
     for i:=0 to StrList.Count-1 Do
         if ReadString(CurrentNick,StrList[i],'') = lvTasks.Selected.Caption then
            Begin
            DeleteKey(CurrentNick,StrList[i]);
            Break;
            End;
     lvTasks.DeleteSelected;
     Free;
     End;

StrList.Free;

end;

end.


