library Scheduler;

uses
  Sharemem,
  SysUtils,
  Forms,
  Windows,
  Classes,
  IniFiles,
  DateUtils,
  wcConsts,
  mmsystem,
  Form_Scheduler,
  ExtCtrls,
  Form_Notification,
  wnd_DefaultWindow  ; //open this file first

{$R *.res}

Type TProcessTimer = Class (TTimer)
     Private
       aName : String;
       Procedure ProcessOnTimer(Sender : TObject);
       Procedure LaunchAction  ;
     Public

       Constructor Create(Name:String); Reintroduce; Overload;
     End;




var
 sPluginName :String ='Test';
 ThreadList  :TList;


Procedure ShutdownThreads;
Begin

while ThreadList.Count>0 do
      Begin
      if not Assigned(TProcessTimer(ThreadList[0])) then
         TProcessTimer(ThreadList[0]).Free;
      ThreadList.Delete(0);
      End;

End;

Procedure WakeUpThreads;
var StrList : TStrings;
    I : Integer;
    aTimer : TProcessTimer;
Begin

ThreadList := Tlist.Create;
With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
     begin
     StrList := TStringList.Create;
     ReadSection(CurrentNick,StrList);
     For I:=0 To StrList.Count-1 Do
         if ReadBool(CurrentNick+ReadString(CurrentNick,StrList[i],''),'Enabled',False) then
            Begin
            aTimer := TProcessTimer.Create(ReadString(CurrentNick,StrList[i],''));
            ThreadList.Add(aTimer);
            End;
     StrList.Free;
     End;

End;



Function GetPluginCaption : ShortString; Stdcall;
Begin

Result := sPluginName;

End;


////////////////////////////////////////////////////////////////////////////////
//
//              DISPLAYS CONFIGURATION WINDOW
//
////////////////////////////////////////////////////////////////////////////////



procedure RunPlugin (ParentApp : THandle;aLoggedUser: String; aSelUser : String;aUsersList : TtblUsers);StdCall;
Begin
CurrentNick := aLoggedUser;
aParentApp :=ParentApp;

tblUsers := aUsersList;

If Assigned(frmScheduler) then
   Exit;

frmScheduler := TfrmScheduler.Create(Nil);
ShutdownThreads;
with frmScheduler do
     Begin
     ShowModal;
     Free;
     frmScheduler := Nil;
     End;
WakeUpThreads;
End;

////////////////////////////////////////////////////////////////////////////////
//
//              LAUNCH ON WINDWOS COMMUNICATOR STARTUP
//
////////////////////////////////////////////////////////////////////////////////
procedure RunPluginAsService (ParentApp : THandle;aLoggedUser: String; aUsersList : TtblUsers);StdCall;
Begin

CurrentNick := aLoggedUser;
aParentApp :=ParentApp;

tblUsers := aUsersList;

WakeUpThreads;

End;

procedure WriteSocketData (SocketID:Integer;SocketData:String); StdCall;
Begin

// this plugin doesn't needs external socket data

End;



Procedure TProcessTimer.LaunchAction;
var I : Integer;
Begin
With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
     Begin
     Case ReadInteger(CurrentNick+aName,'Kind',1) of
           1: Begin
              if not Assigned ( frmNotification ) then
                 Begin
                 frmNotification := TfrmNotification.Create(aName);
                 With frmNotification Do
                      Begin
                      Caption := aName;
                      lblHeader.Caption     := aName;
                      memoNotification.Text := ReadString(CurrentNick+aName,'Message','');
                      cbRemoveTask.Enabled := True;

                      if ReadInteger(CurrentNick+aName,'TimeSchema',1) = 4 then
                         Begin
                          cbAgain.Checked := True;
                          cbAgainClick(Self);
                         End
                         Else
                         Begin
                          cbAgain.Checked := False;
                          cbAgainClick(Self);
                          cbAgain.Enabled := False;
                         End;
                      Show;

                      if (ReadString(CurrentNick+aName,'Sound','')<>'') AND
                         (FileExists(ReadString(CurrentNick+aName,'Sound',''))) then
                         SndPlaySound(PChar(ReadString(CurrentNick+aName,'Sound','')), SND_FILENAME or SND_ASYNC);

                      End;
                 End;
               End;
           2: SendMessage(aParentApp,wm_PluginSocketSend,Longint(Format('127 %s %s',[ReadString(CurrentNick+aName,'User',''),ReadString(CurrentNick+aName,'Message','')])+#13#10),0);
           3: begin

               For I:=0 To tblUsers.Count-1 Do
                 if (TUSer(tblUsers[i]).STATUS <> wcUSer_Offline) and (not TUSer(tblUsers[i]).Ignore) then
                    SendMessage(aParentApp,wm_PluginSocketSend,Longint(Format('226 %s %s',[TUSer(tblUsers[i]).USERNAME,ReadString(CurrentNick+aName,'Message','')])+#13#10),0);

              End;
           4: Begin
              SendMessage(aParentApp,wm_PluginSocketSend,Longint(Format('198 %s %d %d',[ReadString(CurrentNick+aName,'User',''),ReadInteger(CurrentNick+aName,'Method',0),1])+#13#10),0);
              End;
           End;
     Free;
     End;

End;

Constructor TProcessTimer.Create(Name:String);
Begin
inherited Create(Application);

aName := Name;

OnTimer := ProcessOnTimer;

Interval := 1000;
Enabled :=true;

End;


procedure TProcessTimer.ProcessOnTimer(Sender : TObject);
var aDateTime : TDateTime;
Begin


With TIniFile.Create(ExtractFilePath(Application.ExeName)+'Plugins\Scheduler.ini') do
     begin
     If (not SectionExists(CurrentNick+aName)) or (NOT ReadBool(CurrentNick+aName,'Enabled',false)) then
        Begin
        Self.Free;
        Exit;
        End;

     Case ReadInteger(CurrentNick+aName,'TimeSchema',1) of   //WHAT KIND OF SCHEDULE ?
          1: If FormatDateTime('HH:MM:ss',ReadTime(CurrentNick+aName,'Time',Time)) = FormatDateTime('HH:MM:ss',Time) then
                LaunchAction;
          2: Begin
             if (DayOfWeek(Now)=ReadInteger(CurrentNick+aName,'Day',1)) AND
                (FormatDateTime('HH:mm:ss',ReadTime(CurrentNick+aName,'Time',Time))=FormatDateTime('HH:mm:ss',Time)) then
                 LaunchAction;

             End;
          3: Begin
              aDateTime := ReadTime(CurrentNick+aName,'NextUpdate',0);

              if TimeOf(aDateTime)<Time then
                 WriteTime(CurrentNick+aName,'NextUpdate',IncMinute(Time,ReadInteger(CurrentNick+aName,'Minutes',1)));

              If (FormatDateTime('HH:mm',aDateTime)=FormatDateTime('HH:mm',Time)) then
                 Begin
                 WriteTime(CurrentNick+aName,'NextUpdate',IncMinute(Time,ReadInteger(CurrentNick+aName,'Minutes',1)));
                 LaunchAction;
                 end;

             End;
          4: Begin

             If (ReadDate(CurrentNick+aName,'Date',Date) = Date) AND
                (FormatDateTime('hh:mm:ss',ReadTime(CurrentNick+aName,'Time',Time)) = FormatDateTime('hh:mm:ss',Time)) then
                Begin
                LaunchAction;
                WriteBool(CurrentNick+aName,'Enabled',False);
                End;

             if (ReadDate(CurrentNick+aName,'Date',Date) < Date) AND (ReadTime(CurrentNick+aName,'Time',Time) < Time) then
                Begin
                WriteBool(CurrentNick+aName,'Enabled',False);
                Exit;
                End;

             End;
          5: Begin

              if ReadInteger(CurrentNick+aName,'Day',1) = DayOfTheMonth(Date) then
                 if FormatDateTime('HH:mm:ss',ReadTime(CurrentNick+aName,'Time',Time)) = FormatDateTime('HH:mm:ss',Time) then
                 LaunchAction;

             End;
          End;

     Free;
     End;

End;



Exports
 WriteSocketData,
 GetPluginCaption,
 RunPluginAsService,
 RunPlugin;

begin


end.




