unit wcConsts;

interface

Uses Classes,Messages;


Type TUserMode = (umAny,umOnline,umOffline);

Type TUser = Class
     USERNAME        : String[20];
     COMPUTERNAME: String[20];
     EMAIL       : String[40];
     OS          : String[40];
     WCVER       : String[20];
     MAC         : String[25];
     AGE         : Integer;
     GENDER      : Integer;
     WWW         : String[100];
     FIRSTNAME   : String[40];
     SURNAME     : String[40];
     LANG1       : Integer;
     LANG2       : Integer;
     PHONE       : String[40];
     CITY        : String[40];
     STATUS      : Integer;
     IP          : String[16];
     IGNORE      : Boolean;
     LEFTTIME    : TDateTime;
     JoinTime    : TDateTime;
     AwayMSG     : String[200];
//     cliSOCKET      : TWSocket;
     SoundReceiver : Boolean;
     SoundPublisher : Boolean;
     end;

Type
   TtblUsers = Class (TList)
     Public
       Procedure EmptyTable;
       Function LocateName(FieldValue : String):TUser;
       Function LocateFilteredName(Nick : String ; SrchMode : TUserMode):TUser;
//       Function LocateThread(aSocket : TWSocket) :TUser;
       Function GetActiveUsers : TList;
     Public
       Destructor Destroy; Override;
     End;



Const
   wm_PluginSocketSend   = wm_user+1;


var CurrentNick : ShortString;
    CurrentStatus : Byte;
    tblUsers : TtblUsers;


const
//Windows Communicator status
  wcUser_Online  = 0;
  wcUser_Away    = 1;
  wcUser_NA      = 2;
  wcUser_DND     = 3;
  wcUser_Offline = 4;


implementation



{ TtblUsers }

destructor TtblUsers.Destroy;
begin

EmptyTable;

inherited;

end;

procedure TtblUsers.EmptyTable;
begin

While Count>0 do
      Begin
      TUser(Items[0]).Free;
      Delete(0);
      End;

end;

function TtblUsers.GetActiveUsers: TList;
var I : Integer;
    TempList : TList;
begin
TempList := TList.Create;

 For I:=0 To Count-1 Do
     If (TUser(Items[i]).STATUS <> wcUser_Offline) then
        TempList.Add(Items[i]);

Result := TempList ;
end;

function TtblUsers.LocateFilteredName(Nick: String;SrchMode: TUserMode): TUser;
var I : Integer;
begin

Result := Nil ;
 For I:=0 To Count-1 Do
     If TUser(Items[i]).UserName = Nick then
        Begin
        Case SrchMode Of
            umAny    : Result := Items[i];

            umOnline : If (TUser(Items[i]).STATUS <> wcUser_Offline) then
                          Result := Items[i];

            umOffline : If TUser(Items[i]).STATUS = wcUser_Offline then
                           Result := Items[i];
            End;
        Break;
        End;
end;

function TtblUsers.LocateName(FieldValue: String): TUser;
var I : Integer;
begin

Result := Nil ;
 For I:=0 To Count-1 Do
     If TUser(Items[i]).UserName = FieldValue then
        Begin
        Result := Items[i];
        Break;
        End;

end;


{function TtblUsers.LocateThread(aSocket : TWSocket) :TUser;
var I : Integer;
begin
Result := Nil;

if Not Assigned(aSocket) then
   Exit;

For i:=0 To Count-1 do
    Begin
    If (Assigned(TUser(Items[i]).cliSocket) AND
       (aSocket.Handle = TUser(Items[i]).cliSocket.Handle)) then
       Begin
       Result := Items[i];
       Break;
       End;
    End;
end;

 }
end.



